class S:

    def __init__(self, ident, synove=[]):
        self.ident = ident
        self.synove = synove

    def print(self, odsaz=0):
        print("  "*odsaz, self.ident)
        for syn in self.synove:
            syn.print(odsaz+1)

    def pocet_vrcholu(self):
        p = 1
        for syn in self.synove:
            p += syn.pocet_vrcholu()
        return p

    def pocet_listu(self):
        if len(self.synove) == 0:
            return 1
        else:
            p = 0
            for syn in self.synove:
                p += syn.pocet_listu()
            return p

    def hloubka(self):
        if len(self.synove) == 0:
            return 0
        else:
            return 1 + max(syn.hloubka() for syn in self.synove)


strom = S(1, [
    S(2, [S(4), S(5)]),
    S(3)
])
